//+------------------------------------------------------------------+
//|                                       Trader Script1-5digits.mq4 |
//|                                                        Oje Uadia |
//|                                         moneyinthesack@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Oje Uadia"
#property link      "moneyinthesack@yahoo.com"
#property show_inputs
#include <stderror.mqh>
#include <stdlib.mqh> 
#include <LibOrderReliable.mqh>
 extern double Risk_Percent = 0.5;
 extern double lotsize = 0.01;
 extern double takeprofit=300;
 extern double stoploss=100;
 extern bool buy = false;
 extern bool sell =false;
 extern int  MagicNumber = 0;
 double mPoint;
 
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {int ticket;
  if (Digits >= 4) {
      mPoint = 0.0001;
   } else mPoint = 0.01;
//----
if (buy==false && sell==false)
{Alert("Invalid settings, choose to buy or sell by setting one of them to true");
Alert("the script must now be relaunched");
return (0);
}
 if (buy==true && sell == true)  
 {
 Alert("Invalid settings! choose to buy or sell by setting one of them to false");
 Alert("the script must now be relaunched");
return (0);
 }
//----
if (Risk_Percent!=0) lotsize= CalcLots(Risk_Percent, stoploss);

//----
for (int i =0;i<5;i++)
{
if (buy==true)
{
ticket= OrderSendReliable2Step(Symbol(),OP_BUY,lotsize,Ask,7,
          NormalizeDouble(Ask-stoploss*mPoint,Digits),NormalizeDouble(Ask+takeprofit*mPoint,Digits),"",MagicNumber,0,CLR_NONE);
if (ticket>0)
{
Alert("buy order successful");
break;
}
else
Alert("error opening buy order, error code = ", ErrorDescription(GetLastError()));
}
else
if (sell==true)
{
ticket= OrderSendReliable2Step(Symbol(),OP_SELL,lotsize,Bid,7,
        NormalizeDouble(Bid+stoploss*mPoint,Digits),NormalizeDouble(Bid-takeprofit*mPoint,Digits),"",MagicNumber,0,CLR_NONE);
if (ticket>0)
{
Alert("sell order successful");
break;
}
else
Alert("error opening sell order, error code = ", ErrorDescription(GetLastError()));
}
Sleep(3000);
RefreshRates();
}
   return(0);
  }
//+------------------------------------------------------------------+
//+--------------------------------- 
 double CalcLots(double risk, int sl)
{  
   int dig = 0;
   double result = 0;
   RefreshRates();
    if(MarketInfo(Symbol(),MODE_LOTSTEP)==1) dig = 0;
   if(MarketInfo(Symbol(),MODE_LOTSTEP)==0.1) dig = 1;
   if(MarketInfo(Symbol(),MODE_LOTSTEP)==0.01) dig = 2;
   double MM_MinLotSize = MarketInfo(Symbol(),MODE_MINLOT);
   double MM_MaxLotSize = MarketInfo(Symbol(),MODE_MAXLOT);
   double money_to_loss = AccountEquity() * risk/100;
   result = NormalizeDouble(money_to_loss/sl/10,dig);
   if (result < MM_MinLotSize) {result = MM_MinLotSize; Alert("Min/Max-Lotsize overruled");}
   if (result > MM_MaxLotSize) {result = MM_MaxLotSize; Alert("Min/Max-Lotsize overruled");}
   return(result);
}